"{ Package: 'stx:libtool/smallsense' }"

Object subclass:#SmallSenseTypeHolder
	instanceVariableNames:'type'
	classVariableNames:''
	poolDictionaries:''
	category:'SmallSense-Types'
!


!SmallSenseTypeHolder class methodsFor:'instance creation'!

with: aSmallSenseType

    ^self new type: aSmallSenseType; yourself

    "Created: / 16-12-2011 / 01:42:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseTypeHolder methodsFor:'accessing'!

type
    ^ type
!

type:aSmallSenseType

    self assert: aSmallSenseType isTypeHolder not.
    type := aSmallSenseType.

    "Modified: / 16-12-2011 / 02:12:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseTypeHolder methodsFor:'adding & removing'!

addClass: aClass

    self type: (type union: (SmallSenseClassType new klass: aClass)).

    "Created: / 26-11-2011 / 14:04:28 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

addClasses: aCollection

    | union |
    union := SmallSenseUnionType new.
    union addType: type.
    union addTypes: (aCollection collect: [:c|SmallSenseClassType new klass:c]).
    self type: union

    "Created: / 26-11-2011 / 14:04:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseTypeHolder methodsFor:'enumerating'!

classesDo: aBlock

    type classesDo: aBlock

    "Created: / 16-12-2011 / 13:34:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

typesDo: aBlock

    type typesDo: aBlock

    "Created: / 16-12-2011 / 02:17:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseTypeHolder methodsFor:'operations'!

classSide

    ^self class with: type classSide

    "Created: / 16-12-2011 / 13:24:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

instanceSide

    ^self class with: type instanceSide

    "Created: / 16-12-2011 / 13:24:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

union: anotherType

    self type: (type union: anotherType)

    "Created: / 16-12-2011 / 02:18:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseTypeHolder methodsFor:'printing & storing'!

printOn:aStream
    "append a printed representation if the receiver to the argument, aStream"

    type printOn: aStream

    "Modified: / 16-12-2011 / 01:46:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

printWithoutAnglesOn: aStream

    self subclassResponsibility

    "Created: / 16-12-2011 / 01:45:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseTypeHolder methodsFor:'testing'!

isClassType

    ^false

    "Created: / 16-12-2011 / 02:00:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

isTypeHolder

    ^true

    "Created: / 16-12-2011 / 02:05:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

isUnionType

    ^false

    "Created: / 16-12-2011 / 02:00:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseTypeHolder class methodsFor:'documentation'!

version_SVN
    ^ '$Id: SmallSenseTypeHolder.st 7841 2011-12-16 12:43:56Z vranyj1 $'
! !
