"{ Package: 'stx:libtool/smallsense' }"

BrowserEnvironment subclass:#SmallSenseUnacceptedMethodEnvironment
	instanceVariableNames:'class method'
	classVariableNames:'UnacceptedSelector'
	poolDictionaries:''
	category:'SmallSense-Lint'
!


!SmallSenseUnacceptedMethodEnvironment class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    "/ please change as required (and remove this comment)

    UnacceptedSelector := #'* * UnacceptedSelector * *'

    "Modified: / 27-01-2012 / 16:23:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseUnacceptedMethodEnvironment class methodsFor:'instance creation'!

onClass: realClass methodSource: source

    ^self new setupForClass: realClass source: source

    "Created: / 27-01-2012 / 15:38:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseUnacceptedMethodEnvironment methodsFor:'accessing'!

methodsInto:arg
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self shouldImplement
!

selectorsForClass: aClass do: aBlock

    self assert: aClass == class.
    aBlock value: UnacceptedSelector

    "Created: / 27-01-2012 / 15:50:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseUnacceptedMethodEnvironment methodsFor:'accessing-classes'!

classesDo: aBlock 

    ^aBlock value: class.

    "Created: / 27-01-2012 / 15:48:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseUnacceptedMethodEnvironment methodsFor:'initialization'!

setMethod: anUnacceptedMethod

    method := anUnacceptedMethod

    "Created: / 23-01-2012 / 11:20:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setupForClass: realClass source: source


    class := RBClass existingNamed: realClass name.
    method := RBMethod for: class source: source selector: UnacceptedSelector.
    class addMethod: method.

    "Created: / 27-01-2012 / 15:42:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseUnacceptedMethodEnvironment methodsFor:'testing'!

includesSelector: aSelector in: aClass

    ^aClass == method mclass 
        and:[aSelector == #'  fake selector  '].

    "Created: / 27-01-2012 / 15:51:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseUnacceptedMethodEnvironment class methodsFor:'documentation'!

version_SVN
    ^ '$Id: SmallSenseUnacceptedMethodEnvironment.st 7845 2012-01-27 21:20:42Z vranyj1 $'
! !

SmallSenseUnacceptedMethodEnvironment initialize!
